package com.zhongzheng.modules.order.service;

import com.zhongzheng.modules.order.domain.Coupon;
import com.zhongzheng.modules.order.vo.CouponVo;
import com.zhongzheng.modules.order.bo.CouponQueryBo;
import com.zhongzheng.modules.order.bo.CouponAddBo;
import com.zhongzheng.modules.order.bo.CouponEditBo;
import com.baomidou.mybatisplus.extension.service.IService;
import io.swagger.models.auth.In;

import java.util.Collection;
import java.util.List;

/**
 * 【请填写功能名称】Service接口
 *
 * @author change
 * @date 2021-06-15
 */
public interface ICouponService extends IService<Coupon> {
	/**
	 * 查询单个
	 * @return
	 */
	CouponVo queryById(Long couponId);

	Coupon queryByIdAndUserId(Long couponId,Long userId);

	/**
	 * 查询列表
	 */
	List<CouponVo> queryList(CouponQueryBo bo);

	/**
	 * 根据新增业务对象插入【请填写功能名称】
	 * @param bo 【请填写功能名称】新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(CouponAddBo bo);

	/**
	 * 根据编辑业务对象修改【请填写功能名称】
	 * @param bo 【请填写功能名称】编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(CouponEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	/**
	 * 查詢卡券
	 * @param bo 主键集合
	 * @return List<CouponVo>
	 */
	List<CouponVo> queryIssueListCoupon(CouponQueryBo bo);

	/**
	 * 查詢課程活動
	 * @param goodsId 主键集合
	 * @param couponId 主键集合
	 * @return Integer
	 */
    Integer selectCount(Long goodsId, Long couponId);

	List<CouponVo> listUserOrder(Long userId, Integer couponType);
}
